> For the complete documentation index, see [llms.txt](https://docs.zapsign.com.br/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.zapsign.com.br/english/facilitators/sdks/typescript-sdk/documents-requests/createdocfromtemplate.md).

# createDocFromTemplate

### Overview

Parameters:&#x20;

* [DocFromTemplate](/english/facilitators/sdks/typescript-sdk/used-classes/body/docfromtemplate.md)

Return:

* [DocResponse](/english/facilitators/sdks/typescript-sdk/used-classes/response/docresponse.md) - In case of success
* Exception - In case of failure

To create this document we will need:

* set your apiToken;
* build your signers;
* build the document;
* call the method.

### How to use:

Save your [apiToken](/english/master.md):

<pre class="language-typescript"><code class="lang-typescript"><strong>const apiToken: string = "YOUR TOKEN";
</strong></code></pre>

Add your variables to a list of type [DeParaTemplate](https://docs.zapsign.com.br/facilitadores/sdks/sdk-em-typescript/classes-usadas/body/deparatemplate):

<pre class="language-typescript"><code class="lang-typescript"><strong>const fromToTemplateName: DeParaTemplateBuilder = deParaTemplateBuilder()
</strong>        .de("{{FULL NAME}}") // the variable
        .para("Jhon Doe") // the value to replace
        .build();
        
const fromToTemplateSocialSecurty: DeParaTemplateBuilder = deParaTemplateBuilder()
        .de("{{Social Security Number}}")
        .para("9999999999")
        .build();
        
const fromToTemplateAdress: DeParaTemplateBuilder = deParaTemplateBuilder()
        .de("{{Full address}}")
        .para("999 N Main St")
        .build();
        
let fromToTemplates: DeParaTemplatesBuilder[] = [];

fromToTemplates.push(fromToTemplateName, fromToTemplateSocialSecurty, fromToTemplateAdress);
</code></pre>

Build your document with[ DocFromTemplate](/english/facilitators/sdks/typescript-sdk/used-classes/body/docfromtemplate.md) class:

```typescript
const docFromTemplate: DocFomTemplateBuilder = new DocFromTemplateBuilder()
        .withSandbox(false)
        .withPrimaryColor("#000000")
        .withSignerName("My Signer for Template")
        .withTemplateId("YOUR TEMPLATE ID")
        .withData(fromToTemplates)
        .build();
```

Finally, call the createDocFromTemplate method to get the [DocResponse](/english/facilitators/sdks/typescript-sdk/used-classes/response/docresponse.md) return or an error[ ](https://docs.zapsign.com.br/facilitadores/sdks/sdk-em-typescript/classes-usadas/response/docresponse)message:

```typescript
async function exempleCreateDocFromTemplate() {
        try {
                docResponse: DocResponse = await new DocRequests(apiToken).createDocFromTemplate(docFromTemplate);
                jsonDocResponse: string = new JsonConverter().docAsyncResponseToJson(docResponse);
                console.log(jsonDocResponse);
            } catch(Err) {
                console.log(Err);
            }
}
```

### Example:

<pre class="language-typescript"><code class="lang-typescript">import { DeParaTemplateBuilder } from "sdk-node-typescript-zapsign/src/body/doc/builders/DeParaTemplateBuilder";
import DocRequests from "sdk-node-typescript-zapsign/src/docs/DocRequests";
import { JsonConverter } from "sdk-node-typescript-zapsign/src/services/JsonConverter";
import { DocFromTemplate } from "sdk-node-typescript-zapsign/src/body/doc/builders/DocFromTemplate";
<strong>
</strong><strong>const apiToken: string = "YOUR TOKEN";
</strong><strong>
</strong>const fromToTemplateName: DeParaTemplateBuilder = DeParaTemplateBuilder()
        .de("{{Full Name}}")
        .para("Jhon Doe")
        .build();
        
const fromToTemplateCpf: DeParaTemplateBuilder = DeParaTemplateBuilder()
        .de("{{Social Security Number}}")
        .para("9999999999")
        .build();
        
const fromToTemplateEndereco: DeParaTemplateBuilder = DeParaTemplateBuilder()
        .de("{{Full address}}")
        .para("999 N Main St")
        .build();
        
let fromToTemplates: DeParaTemplatesBuilder[] = [];

fromToTemplates.push(fromToTemplateName, fromToTemplateCpf, fromToTemplateEndereco);

const docFromTemplate: DocFomTemplateBuilder = new DocFromTemplateBuilder()
        .withSandbox(false)
        .withPrimaryColor("#000000")
        .withSignerName("My Signer for Template")
        .withTemplateId("YOUR TEMPLATE ID")
        .withData(fromToTemplates)
        .build();

async function exempleCreateDocFromTemplate() {
        try {
                docResponse: DocResponse = await new DocRequests(apiToken).createDocFromTemplate(docFromTemplate);
                jsonDocResponse: string = new JsonConverter().docAsyncResponseToJson(docResponse);
                console.log(jsonDocResponse);
            } catch(Err) {
                console.log(Err);
            }
}
</code></pre>


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.zapsign.com.br/english/facilitators/sdks/typescript-sdk/documents-requests/createdocfromtemplate.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
